summaryrefslogtreecommitdiff
path: root/tests/misc/readlink-fp-loop
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2007-09-24 09:53:57 +0200
committerJim Meyering <jim@meyering.net>2007-09-27 10:53:08 +0200
commitbeaa39a649939cf19994bf773871a810ef896701 (patch)
tree0554eb184af1630bb51519035722fac2c5b14330 /tests/misc/readlink-fp-loop
parent23d293cbc2d894d7ad10859421b655d1cb201c5b (diff)
downloadcoreutils-beaa39a649939cf19994bf773871a810ef896701.tar.xz
Add a test to exercise a readlink bug.
* tests/misc/readlink-fp-loop: New file. Test for the readlink bug fixed through today's change to Gnulib's canonicalize module. * tests/misc/Makefile.am (TESTS): Add readlink-fp-loop. Bug report and a test case from mpb.mail@gmail.com.
Diffstat (limited to 'tests/misc/readlink-fp-loop')
-rwxr-xr-xtests/misc/readlink-fp-loop69
1 files changed, 69 insertions, 0 deletions
diff --git a/tests/misc/readlink-fp-loop b/tests/misc/readlink-fp-loop
new file mode 100755
index 000000000..9a4472b6f
--- /dev/null
+++ b/tests/misc/readlink-fp-loop
@@ -0,0 +1,69 @@
+#!/bin/sh
+# readlink from 6.9 would fail with a false-positive symlink loop error
+
+# Copyright (C) 2007 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ readlink --version
+fi
+
+. $srcdir/../test-lib.sh
+cwd=$("$abs_top_builddir/src/pwd")
+
+# To trigger this bug, we have to construct a name/situation during
+# the resolution of which the code dereferences the same symlink (S)
+# two different times with no actual loop. In addition, arrange
+# so that the second and fourth calls to readlink operate on S.
+
+ln -s s p || framework_failure
+ln -s d s || framework_failure
+mkdir d || framework_failure
+echo 2 > d/2 || framework_failure
+ln -s ../s/2 d/1 || framework_failure
+
+fail=0
+# With coreutils-6.9, this would fail with ELOOP.
+readlink -v -e p/1 > out || fail=1
+# readlink -e d/2 > exp || fail=1
+echo "$cwd/d/2" > exp || fail=1
+compare out exp || fail=1
+
+# Construct a real loop and make sure readlink still detects it.
+ln -sf ../s/1 d/2 || framework_failure
+readlink -v -e p/1 2> out && fail=1
+echo readlink: p/1: Too many levels of symbolic links > exp || framework_failure
+compare out exp || fail=1
+
+# Exercise the hash table code.
+ln -nsf ../s/3 d/2 || framework_failure
+ln -nsf ../p/4 d/3 || framework_failure
+ln -nsf ../p/5 d/4 || framework_failure
+ln -nsf ../p/6 d/5 || framework_failure
+ln -nsf ../p/7 d/6 || framework_failure
+ln -nsf ../p/8 d/7 || framework_failure
+echo x > p/1 || framework_failure
+readlink -v -e p/1 > out || fail=1
+echo "$cwd/d/8" > exp || fail=1
+compare out exp || fail=1
+
+# A trivial loop
+ln -s loop loop
+readlink -v -e loop 2> out && fail=1
+echo readlink: loop: Too many levels of symbolic links > exp || framework_failure
+compare out exp || fail=1
+
+(exit $fail); exit $fail